package com.businesscompassllc.sqlitedemo;


import java.util.ArrayList;
import java.util.List;
import java.util.TimeZone;




import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.ActionBar;
import android.support.v4.app.Fragment;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.res.ColorStateList;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.os.Build;


public class SQLiteDemo extends ListActivity {

	Button add, delete,update;
	EditText part_number, part_name, part_price;
	String  partName;
	int partNumber;
	double partPrice;
	List<Part> partList;
	ArrayAdapter<Part> adapter;
	 PartDB db;
	private static ColorStateList allWhite=ColorStateList.valueOf(0xFFFFFFFF);
	private static final int ONE_ID = Menu.FIRST+7;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sqlite_demo);

		db=new PartDB(this);
	
		db.deleteAllPart();
		db.addPart(new Part(1,"Motor",12.5));
		db.addPart(new Part(2,"Engine",13.5));
		db.addPart(new Part(3,"Fan",14.5));
		db.addPart(new Part(4,"Wheel",15.5));
		
		partList = db.getAllParts();
		
		for (int i=0;i<partList.size();i++)
			printPart(partList.get(i),"ALL PARTS");
		
		part_number=(EditText) findViewById(R.id.part_number);
		part_name=(EditText) findViewById(R.id.part_name);
		part_price=(EditText) findViewById(R.id.part_price);
		
		add=(Button) findViewById(R.id.add);
		update=(Button) findViewById(R.id.update);
		delete=(Button) findViewById(R.id.delete);
		

		
		
	//	Toast.makeText(getApplicationContext(), " " + db.getPartCount(), Toast.LENGTH_SHORT).show();
		
		if (db.getPartCount()>0) Toast.makeText(getApplicationContext(), " " + partList.get(1).getNumber() + " "+ partList.get(1).getName() + " " + partList.get(1).getPrice(), Toast.LENGTH_SHORT).show();
		


setListAdapter(new SelectorAdapter(this));
getListView().setOnItemSelectedListener(onItemSelectedListener);
getListView().setSelection(0);

getListView().setOnItemClickListener(onItemClickListener);

registerForContextMenu(getListView());


	    
		add.setOnClickListener(new View.OnClickListener() {
		    @Override
		    public void onClick(View v) {
		    
		    
		    	Part part=new Part(Integer.valueOf(part_number.getText().toString()).intValue(),
		    			part_name.getText().toString(),
		    			Double.valueOf(part_price.getText().toString()).doubleValue());
		
		    	db.addPart(part);
		    	Toast.makeText(getApplicationContext(), "Add " + Integer.valueOf(part_number.getText().toString()).intValue() + " " + part_name.getText().toString() + " " + Double.valueOf(part_price.getText().toString()).doubleValue(), Toast.LENGTH_SHORT).show();
				 
		    	printPart(part,"ADD PART");
		    	
		    	Log.e("PART OBJECT - "," ADD data from EditText");
		     
		        Log.e("COL_NUMBER", "" +Integer.valueOf(part_number.getText().toString()).intValue());
		        Log.e("COL_NAME", "" +part.getName());
		        Log.e("COL_PRICE", "" +Double.valueOf(part_price.getText().toString()).doubleValue());
		    	
		    updateList();

		    }
		});
		
		update.setOnClickListener(new View.OnClickListener() {
		    @Override
		    public void onClick(View v) {

		    	Part part=new Part(Integer.valueOf(part_number.getText().toString()).intValue(),
		    			part_name.getText().toString(),
		    			Double.valueOf(part_price.getText().toString()).doubleValue());
		
		    	db.updatePart(part);
		    	Toast.makeText(getApplicationContext(), "Update", Toast.LENGTH_SHORT).show();
			    updateList();
		    }
		});
		
		delete.setOnClickListener(new View.OnClickListener() {
		    @Override
		    public void onClick(View v) {

		    	Part part=new Part(Integer.valueOf(part_number.getText().toString()).intValue(),
		    			part_name.getText().toString(),
		    			Double.valueOf(part_price.getText().toString()).doubleValue());
		
		    	db.deletePart(part);
		    	Toast.makeText(getApplicationContext(), "Delete", Toast.LENGTH_SHORT).show();
			    updateList();
		    }
		});
		
	}

	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenu.ContextMenuInfo menuInfo) {
			populateMenu(menu);
			}
	@Override
			public boolean onCreateOptionsMenu(Menu menu) {
			//theMenu=menu;
			new MenuInflater(getApplication())
			.inflate(R.layout.menu, menu);
		return(super.onCreateOptionsMenu(menu));
			}
			@Override
			public boolean onOptionsItemSelected(MenuItem item) {
		
				super.finish();
				return(applyMenuChoice(item) ||
						super.onOptionsItemSelected(item));
			}
			@Override
			public boolean onContextItemSelected(MenuItem item) {
				super.finish();
				return(applyMenuChoice(item) ||
						super.onOptionsItemSelected(item));
			}
			private void populateMenu(Menu menu) {
			menu.add(Menu.NONE, ONE_ID, Menu.NONE, "Exit");
			
			}
			private boolean applyMenuChoice(MenuItem item) {
			switch (item.getItemId()) {
			case ONE_ID: return true; 
			default: return false;
			}
			}

	class SelectorAdapter extends ArrayAdapter<Part> {
		SelectorAdapter(Context ctxt) {

			//super(ctxt, R.layout.row_my_cities, myCities[0]);
			super(ctxt, R.layout.row, partList);
			
		}
		@Override
		public View getView(int position, View convertView,
		ViewGroup parent) {
		SelectorWrapper wrapper=null;
		if (convertView==null) {
		convertView=getLayoutInflater().inflate(R.layout.row,
		null);
		wrapper=new SelectorWrapper(convertView);
		//wrapper.getLabelPartNumber().setTextColor(allWhite);
		//wrapper.getLabelPartName().setTextColor(allWhite);
		//wrapper.getLabelPartPrice().setTextColor(allWhite);
		convertView.setTag(wrapper);
		}
		else {
		wrapper=(SelectorWrapper)convertView.getTag();
		}
		
		printPart(((Part)partList.get(position)),"WRAPPER");
		wrapper.getLabelPartNumber().setText(Integer.valueOf(((Part)partList.get(position)).getNumber()).toString());
		//wrapper.getLabelPartName().setText("part name");
		wrapper.getLabelPartName().setText(((Part)(partList.get(position))).getName());
		//wrapper.getLabelPartPrice().setText("12.5");
		wrapper.getLabelPartPrice().setText(Double.valueOf(((Part)partList.get(position)).getPrice()).toString());
			return(convertView);
		}
		}
	
		class SelectorWrapper {
		View row=null;
		TextView labelPartNumber=null;
		View bar=null;
		TextView labelPartName=null;
		TextView labelPartPrice=null;
		SelectorWrapper(View row) {
			this.row=row;
			}

			TextView getLabelPartNumber() {
			if (labelPartNumber==null) {
			labelPartNumber=(TextView)row.findViewById(R.id.labelPartNumber);
			}
			return (labelPartNumber);
			}
			
			TextView getLabelPartName() {
			if (labelPartName==null) {
			labelPartName=(TextView)row.findViewById(R.id.labelPartName);
			}
			return (labelPartName);
			}
			
			TextView getLabelPartPrice() {
				if (labelPartPrice==null) {
				labelPartPrice=(TextView)row.findViewById(R.id.labelPartPrice);
				
				}
				return(labelPartPrice);
			}
			
			View getBar() {
			if (bar==null) {
			bar=row.findViewById(R.id.bar);
			}
			return(bar);
			}
			}
			AdapterView.OnItemSelectedListener onItemSelectedListener=new
			AdapterView.OnItemSelectedListener() {
			View lastRow=null;
			public void onItemSelected(AdapterView<?> parent,
			View view, int position,
			long id) {
				
				Log.e("ON ITEM SELECTED", "" + position);
				part_number.setText(Integer.valueOf(partList.get(position).getNumber()).toString());
				part_name.setText(partList.get(position).getName());
				part_price.setText(Double.valueOf(partList.get(position).getPrice()).toString());
				
			if (lastRow!=null) {
			SelectorWrapper wrapper=(SelectorWrapper)lastRow.getTag();
			wrapper.getBar().setVisibility(View.INVISIBLE);
			}
			SelectorWrapper wrapper=(SelectorWrapper)view.getTag();
			wrapper.getBar().setVisibility(View.VISIBLE);
			lastRow=view;

			
			}
			public void onNothingSelected(AdapterView<?> parent) {
			if (lastRow!=null) {
			SelectorWrapper wrapper=(SelectorWrapper)lastRow.getTag();
			wrapper.getBar().setVisibility(View.INVISIBLE);
			wrapper.getLabelPartNumber().setVisibility(View.INVISIBLE);
			wrapper.getLabelPartName().setVisibility(View.INVISIBLE);
			wrapper.getLabelPartPrice().setVisibility(View.INVISIBLE);
			lastRow=null;
			}
			}
			};
			
			OnItemClickListener onItemClickListener=new
					OnItemClickListener() {
				
					
					public void onItemClick(AdapterView<?> parent,
					View view, int position,
					long id) {
						
						Log.e("ON ITEM SELECTED", "" + position);
						part_number.setText(Integer.valueOf(partList.get(position).getNumber()).toString());
						part_name.setText(partList.get(position).getName());
						part_price.setText(Double.valueOf(partList.get(position).getPrice()).toString());
						
					

					
					}
				
					};

			private void updateList() {
				
				partList.clear();
				
				partList = db.getAllParts();
				
				
				//getListView().invalidateViews();
				
				//getListView().setAdapter(this.adapter);
				
				Toast.makeText(getApplicationContext(), " " + db.getPartCount(), Toast.LENGTH_SHORT).show();
				
				//setListAdapter((SelectorAdapter)this.getListAdapter());
				
				setListAdapter(new SelectorAdapter(this));
				//getListView().setOnItemSelectedListener(listener);
				//getListView().setSelection(0);

				//registerForContextMenu(getListView());
			    // use the SimpleCursorAdapter to show the
			    // elements in a ListView
			/*  adapter = new ArrayAdapter<Part>(this,
			        android.R.layout.simple_list_item_1, partList);
			    setListAdapter(adapter);*/
			   // adapter.notifyDataSetChanged();
			}
			
			private void printPart(Part part,String Tag)
			{
				Log.e("PART OBJECT - ",Tag);
		        Log.e("COL_NUMBER", "" +part.getNumber());
		        Log.e("COL_NAME", "" +part.getName());
		        Log.e("COL_PRICE", "" +part.getPrice());
		       
			}
}
